]> git.phdru.name Git - dotfiles.git/blob - .shellrc
.fvwm/main.m4: Iconify Firefox' 1st window instead of lowering
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 OPS1="$OPS1\\$"
62 PS1="$OPS1 "
63
64
65 if test -n "$BASH_VERSION"; then
66    [ "`type -t ls`" = alias ] && unalias ls
67    [ "`type -t ll`" = alias ] && unalias ll
68    [ "`type -t mc`" = alias ] && unalias mc
69
70    back() { cd - "$@"; }
71    functions() { typeset -f "$@"; }
72    j() { jobs; }
73
74    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
75       if [ "$SHELL" = /bin/bash ]; then
76          if [ -f /etc/bash_completion ]; then
77             . /etc/bash_completion
78          elif [ -d /etc/bash_completion.d ]; then
79             for _compf in /etc/bash_completion.d/*; do
80                . $_compf
81             done
82          fi
83       elif [ "$SHELL" = /usr/local/bin/bash ]; then
84          if [ -d /usr/local/etc/bash_completion.d ]; then
85             for _compf in /usr/local/etc/bash_completion.d/*; do
86                . $_compf
87             done
88          fi
89       else
90          echo "Unknown OS type, cannot source bash_completion" >&2
91       fi
92    fi
93
94    has_completion() { return 0; }
95    if [ "$SHELL" = /bin/bash ]; then
96       if [ -d /etc/bash_completion.d -o -d /usr/share/bash-completion/completions ]; then
97          has_completion() { [ -r /etc/bash_completion.d/$1 -o -r /usr/share/bash-completion/completions/$1 ]; }
98       fi
99    elif [ "$SHELL" = /usr/local/bin/bash ]; then
100       if [ -d /usr/local/etc/bash_completion.d ]; then
101          has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
102       fi
103    fi
104
105    for cmd in builtin cgmem_nice command dbus-launch exec \
106       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
107       time whence whereis which xargs; do
108          ! has_completion $cmd && complete -o default -A command $cmd
109    done
110
111    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
112       telnet t tt \
113       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
114       whois wget wget-m wget-wrapper ww; do
115          ! has_completion $cmd && complete -A hostname $cmd
116    done
117
118    for cmd in distribute ftp lftp r rsync \
119       s scp ssh smbclient tcpdump tshark wireshark; do
120          ! has_completion $cmd && complete -o default -A hostname $cmd;
121    done
122
123    delegate_completion() {
124       local prog programs
125       prog=$1
126       if has_completion $prog; then
127          shift
128          programs="$@"
129          eval "_${prog}_completion_loader() {
130             _completion_loader $prog
131             complete -F _$prog $programs
132             unset _${prog}_completion_loader
133             return 124
134          }"
135          complete -F _${prog}_completion_loader $programs
136       fi
137    }
138
139    delegate_completion make m
140    delegate_completion ping p
141    delegate_completion rsync r
142    delegate_completion ssh s
143    delegate_completion wget wget-m wget-wrapper ww
144
145    unset has_completion delegate_completion
146
147    complete -A job bg fg j jobs wait
148    complete -A variable -A function unset
149
150    if [ -d "$HOME/lib/config" ]; then
151       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
152    fi
153    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
154
155    #if type -p pip >/dev/null 2>&1; then
156    #   eval "`pip completion --bash`"
157    #   rm -rf /tmp/pip_build_"$USER"
158    #fi
159
160    #if which pyenv >/dev/null 2>&1; then
161    #   eval "`pyenv init -`"
162    #   eval "`pyenv virtualenv-init -`"
163    #fi
164
165    source virtualenvwrapper_lazy.sh 2>/dev/null
166
167    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
168       . "$VIRTUAL_ENV/bin/activate"
169    fi
170
171 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
172    back() { cd - "$@"; }
173    j() { jobs; }
174 fi
175
176
177 # clear screen and history, logout
178 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
179
180
181 if test -x /usr/bin/git >/dev/null 2>&1; then
182    # chdir to a remote's directory (if the remote is on the local FS)
183    cdremote() {
184       if [ -z "$1" ]; then
185          branch="`git rev-parse --abbrev-ref HEAD`"
186          remote="`git config --get branch.$branch.remote`"
187       elif [ -n "$2" ]; then
188          echo "Usage: cdremote [remote_name]" >&2
189          return 1
190       else
191          remote="$1"
192       fi
193
194       if [ -z "$remote" ]; then
195          echo "Cannot find remote for branch $branch" >&2
196          echo "Usage: cdremote [remote_name]" >&2
197          return 1
198       fi
199
200       cd "`git config --get remote.$remote.url`"
201    }
202
203    if test -n "$BASH_VERSION"; then
204       # completion for aliases in global .gitconfig
205
206       # fixup rbi rbia rbiap rbip - do refs name completion
207       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
208       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
209       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
210       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
211       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
212       #
213       # push-to-all-remotes - do branch name completion
214       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
215
216       # list remotes with URLs matching a regexp
217       _list_remotes() {
218          if [ -z "$1" -o -n "$2" ]; then
219             echo "Usage: _list_remotes remote_regexp" >&2
220             return 1
221          fi
222          GIT_REMOTES=""
223          local remote
224          for remote in `git remote`; do
225             if git config --get remote.$remote.url | grep -q "$1"; then
226                GIT_REMOTES="$GIT_REMOTES $remote"
227             fi
228          done
229       }
230
231       # completion for cdremote and git-open - list remotes with a pattern
232       _list_remotes_completion() {
233          local cur="${COMP_WORDS[COMP_CWORD]}";
234          _list_remotes "$1"
235          COMPREPLY=(`compgen -W "$GIT_REMOTES" -- "$cur"`)
236          unset GIT_REMOTES
237       }
238
239       # completion for cdremote - list remotes with directories as URLs
240       _cdremote_complete() {
241          _list_remotes_completion '^\(/\|\.\./\)' # (/ or ../ at the beginning)
242       }
243
244       complete -F _cdremote_complete cdremote
245
246       # completion for git-open - list remotes with http(s) URLs
247       _git_open() {
248          _list_remotes_completion '^http\(s\)\?://'
249       }
250
251       complete -F _git_open git-open
252    fi
253 fi
254
255
256 include() {
257    cfg="$1"
258    if [ -f "./$cfg" -a -r "./$cfg" ]; then
259       echo "Reading config file \`$cfg'" 1>&2
260       . "./$cfg"
261    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
262       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
263       . "$HOME/lib/config/$cfg"
264    else
265       echo "Cannot find config file \`$cfg'" 1>&2
266    fi
267 }
268
269
270 mc() {
271    if test -n "$BASH_VERSION"; then
272       MC_SAVE_OPS1="$OPS1"
273       OPS1="\u@\h "
274    fi
275
276    if [ -n "$SLOWTERM" ]; then
277       MC_SLOW="--slow"
278    fi
279
280    case "$TERM" in
281       screen*) # screen, screen.rxvt
282          if [ "$TERM" = screen.rxvt ]; then
283             MC_SAVE_TERM="$TERM"
284             TERM=rxvt
285          fi
286          MC_XTERM="-x"
287       ;;
288    esac
289
290    #TMPDIR="$HOME"/tmp
291    #export TMPDIR
292
293    MC_FOUND=NO
294
295    for wrapper in \
296          /usr/local/share/mc/bin/mc-wrapper.sh \
297          /usr/local/libexec/mc/mc-wrapper.sh \
298          /usr/share/mc/bin/mc-wrapper.sh; do
299       if [ -r $wrapper ]; then
300          . $wrapper $MC_SLOW $MC_XTERM "$@"
301          rc=$?
302          MC_FOUND=YES
303          break
304       fi
305    done
306
307    if [ $MC_FOUND = NO ]; then
308       for mc in /usr/local/bin/mc /usr/bin/mc; do
309          if [ -x $mc ]; then
310             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
311             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
312                MC_TMP_DIR="${TMPDIR-/tmp}"
313             fi
314             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
315             mc_type="`mc_type.py $mc`"
316             if [ "$mc_type" = old ]; then
317                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
318             elif [ "$mc_type" = new ]; then
319                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
320             else
321                continue
322             fi
323             rc=$?
324             MC_FOUND=YES
325             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
326             break
327          fi
328       done
329    fi
330
331    if [ $MC_FOUND = NO ]; then
332       echo "Cannot find mc-wrapper.sh or mc" >&2
333       rc=1
334    fi
335
336    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
337    [ -n "$MC_SAVE_TERM" ] && TERM="$MC_SAVE_TERM"
338    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SAVE_TERM \
339          MC_SLOW MC_TMP_DIR MC_XTERM
340
341    return $rc
342 }
343
344
345 mkcd() {
346    if [ $# -ne 1 ]; then
347       echo "Usage: mkcd directory_name" >&2
348    elif [ -d "$1" ]; then
349       cd "$1"
350    elif [ -e "$1" ]; then
351       echo "Error: $1 is a file" >&2
352    else
353       mkdir -p "$1" && cd "$1"
354    fi
355 }
356
357
358 if which tmux >/dev/null 2>&1; then
359    tmux() {
360       case "$TERM" in
361          rxvt)
362             TERM=rxvt-unicode command tmux "$@"
363          ;;
364
365          *)
366             command tmux "$@"
367          ;;
368       esac
369    }
370 fi
371
372
373 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
374    X() { startx >> .Xserver.log 2>&1; cyr; }
375 fi
376
377 x() { exit; }